'                   Uhr

' lt Led (Rot)am Ausgang Port BD.5 im 1 Herz Rythmus blinken
'
' Timer wird auf einen bestimmten Wert voreingestellt
' Um auf eine 1 Hz Zeitbasis zu kommen.
' Dazu wird erst einmal die Frequenz des Quarz durch 1024 geteilt
' ist in diesem Fall 3600.
' Diser Wert wird vom Hchsten Zhlwert subtrahiert
' Also 1024 minus 3600 bleibt 61935 brig
' Dieser Wert wird voreingestellt
'
' ber Taster an D2 werden die Stunden eingestellt
' ber Taster an D3 werden die Minuten eingestellt
' Beim drcken beider Taster gleichzeitig, wird Uhr auf Null zurckgestellt

'---------------- Pinbelegung--------------------------------------------------
' Display an folgenden Ports
' Enable = Port B.5
' RS     = Port B.4
' DB7    = Port B.3
' DB6    = Port B.2
' DB5    = Port B.1
' DB4    = Port B.0
' Taster an Port D.2
' Taster an Port D.3
' Led    an Port D.5 Rot
' Led    an Port D.7 Blau
'------------------------------------------------------------------------------
$baud = 9600
$regfile "m8def.dat"          'Definiert den Atmega als Atmega 8
$crystal = 3686400            'Gibt die Quarzfrequenz an in Herz
Config Lcd = 16 * 2           'definiert das LCD Display in Art und Gre
Dim Sekunde As Word           'Variable in der Sekunden gespeichert werden
Dim Minute As Word            'Variable in der Minuten gespeichert werden
Dim Stunde As Word            'Variable in der Stunden gespeichert werden
Dim S1 As String * 2          'Bentigt fr Formatumwandlung der Stunden
Dim S2 As String * 2          'Bentigt fr Formatumwandlung der Minuten
Dim S3 As String * 2          'Bentigt fr Formatumwandlung der Sekunden


Ddrd = &B10100000             ' Port d.5 und d.7 als Ausgang,alle anderen
                              ' als Eingang definieren
Portd = &B00001100            ' PullUp von Portd2 und Portd.3 aktivieren

Config Timer1 = Timer , Prescale = 1024       'Bestimmt das Timer 1 verwendet
                                                'wird und teilt Takt durch 1024
Enable Timer1                 'startet Timer 1
On Timer1 Test                'Hier wird dem Timer gesagt das er zum
'Programmpunkt Test springen soll wenn der Timer einen berlauf meldet
Enable Interrupts             'Hier wird der Interuppt aktiviert
Timer1 = 61935                ' Voreinstellung des timers
'------------ Uhr Voreinstellung ----------------------------------------------
Sekunde = 0
Minute = 0
Stunde = 0
'**************** Hier kommt das Hauptprogramm rein ***************************
Do                            ' Schleifenanfang
Portd.5 = 0                   ' Led Rot aus
Portd.7 = 0                   ' Led blau aus
Cls                           ' Display lschen

'-------------------- Formatkonvertierung fr Uhrzeit -------------------------
' Hier wird unter zuhilfenahme der Zeile 34-35-36 die Variablen fr die
' Uhrzeit in einen String mit 2 Zeichen umgewandelt, damit Sekunden , Minuten
' und Stunden , jeweils mit einer Vorangestellten Null angezeigt werden.

S1 = Str(stunde)
S1 = Format(s1 , "00")
'----------------------------------
S2 = Str(minute)
S2 = Format(s2 , "00")
'------------------------------------
S3 = Str(sekunde)
S3 = Format(s3 , "00")
'--------------------------------------
' S1 ist nun die Variable fr Stunde
' S2 ist nun die Variable fr Minuten
' S3 ist nun die Variable fr Sekunden

'----------- Anzeige Stunden , Minuten, Sekunden auf Display ------------------

Locate 1 , 15                 ' Position auf Display
Lcd S3
Locate 1 , 12
Lcd ":"
Locate 1 , 10
Lcd S2
Locate 1 , 8
Lcd ":"
Locate 1 , 6                  ' Sekunde auf Display anzeigen
Lcd S1
Locate 1 , 1
Lcd "Uhr"
Cursor Off Noblink            ' Cursor Ausblenden
Waitms 50                     ' Pause 50 ms
'------------ Anzeigen Stunden, Minuten, Sekunden auf Terminal ----------------
Print "Uhrzeit" ; " " ; S1 ; ":" ; S2 ; ":" ; S3

'----Stunden Minuten Sekunden beim berlauf auf Null setzen--------------------
 If Sekunde > 59 Then Minute = Minute + 1
 If Sekunde > 59 Then Sekunde = 0
 If Minute > 59 Then Stunde = Stunde + 1
 If Minute > 59 Then Minute = 0
 If Stunde > 23 Then Stunde = 0

'--------------Uhr einstellen Minute ------------------------------------------
 If Pind.2 = 0 Then
 Waitms 50
 If Pind.2 = 0 Then
 Incr Stunde
 If Pind.2 = 0 Then Portd.7 = 1
 Else
 Portd.7 = 0
 End If
End If
 '--------------Uhr einstellen Stunde -----------------------------------------
If Pind.3 = 0 Then
Waitms 50
If Pind.3 = 0 Then
Incr Minute
If Pind.3 = 0 Then Portd.7 = 1
Else
Portd.7 = 0
End If
End If
'--------Uhr komplett auf Null stellen ----------------------------------------
If Pind.2 = 0 And Pind.3 = 0 Then
Sekunde = 0
Minute = 0
Stunde = 0
Portd.7 = 1
Waitms 50
End If
'------------------------------------------------------------------------------
 Loop

   End
'**************** Ende Hauptprogramm ******************************************

'--------------------Sprungmarke von Timer 1 ----------------------------------
 Test:
Incr Sekunde                  ' Zhlt Sekunde immer um einen Wert hoch
Timer1 = 61935                ' Timer soll ab 61935 hochzhlen
Portd.5 = 1                   ' Lt rote Led blinken
                              'wechsel Ausgang Port d.7
 Return
'------------------------------------------------------------------------------